
%global debug_package   %{nil}

%global provider        github
%global provider_tld    com
%global project         prometheus
%global repo            prometheus
# https://github.com/prometheus/prometheus
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          85f23d82a045d103ea7f3c89a91fba4a93e6367a
%global shortcommit     %(c=%{commit}; echo ${c:0:7})
%global build_gopath    %{_builddir}/%{repo}-%{shortcommit}-go
%global upstream_ver    2.1.0
%global rpm_ver         %(v=%{upstream_ver}; echo ${v//-/_})

Name:	        golang-%{provider}-%{project}-%{repo}
Version:	%{rpm_ver}
Release:	1.git%{shortcommit}%{?dist}
Summary:	The Prometheus monitoring system and time series database
License:	ASL 2.0 
URL:		https://prometheus.io/
Source0:        https://%{provider}.%{provider_tld}/openshift/%{repo}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
Patch0:         0001-Don-t-check-the-network-for-updates-to-promu.patch
Patch1:		0002-Strip-debug-info-from-go-binary.patch

# promu build tool used for building prometheus
%global promu_repo      promu
%global promu_prefix    %{provider}.%{provider_tld}/%{project}/%{promu_repo}
%global promu_commit    00403b4391efa0bbf92f369b72143609929b95e6
%global promu_shortcmt  %(c=%{promu_commit}; echo ${c:0:7})
Source1:       https://%{promu_prefix}/archive/%{promu_commit}/%{promu_repo}-%{promu_shortcmt}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
# promu-based packages FTBFS on aarch64 (#1487462)
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm} ppc64le s390x}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires: %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}	
#Requires:	

%description
%{summary}

%package -n %{repo}
Summary:        %{summary}
Provides:       prometheus = %{version}-%{release}

%description -n %{repo}
%{summary}

%prep
%setup -q -T -n %{promu_repo}-%{promu_commit} -b 1
%setup -q -n %{repo}-%{commit}
%patch0 -p1
%patch1 -p1

%build
mkdir -p %{build_gopath}/src/%{provider}.%{provider_tld}/%{project}
# Link the extracted source directories to the expected GOPATH layout
ln -s ../../../../%{repo}-%{commit} %{build_gopath}/src/%{import_path}
ln -s ../../../../%{promu_repo}-%{promu_commit} %{build_gopath}/src/%{promu_prefix}

export GOPATH=%{build_gopath}
unset GOBIN
cd %{_builddir}/%{repo}-%{commit}
make build

%install
install -d -p %{buildroot}%{_bindir}
export PROM_BUILDDIR="%{_builddir}/%{repo}-%{commit}"
install -D -p -m 0755 ${PROM_BUILDDIR}/prometheus %{buildroot}%{_bindir}/prometheus
install -D -p -m 0755 ${PROM_BUILDDIR}/promtool %{buildroot}%{_bindir}/promtool
install -d %{buildroot}%{_sysconfdir}/prometheus
install -D -p -m 0644 ${PROM_BUILDDIR}/documentation/examples/prometheus.yml %{buildroot}%{_sysconfdir}/prometheus/prometheus.yml
install -d %{buildroot}%{_datadir}/prometheus/console_libraries
install -D -p -m 0644 ${PROM_BUILDDIR}/console_libraries/* %{buildroot}%{_datadir}/prometheus/console_libraries
install -d %{buildroot}%{_datadir}/prometheus/consoles
install -D -p -m 0644 ${PROM_BUILDDIR}/consoles/* %{buildroot}%{_datadir}/prometheus/consoles

%files -n %{repo}
%license LICENSE NOTICE
%doc CHANGELOG.md CONTRIBUTING.md MAINTAINERS.md README.md
%config %{_sysconfdir}/prometheus/prometheus.yml
%{_bindir}/prometheus
%{_bindir}/promtool
%{_datadir}/prometheus/console_libraries
%{_datadir}/prometheus/consoles

%changelog
* Wed Feb 21 2018 Paul Gier <pgier@redhat.com> - 2.1.0-1
- Upgrade to 2.1.0

* Wed Jan 10 2018 Yaakov Selkowitz <yselkowi@redhat.com> - 2.0.0-2.git0a74f98
- Rebuilt for ppc64le, s390x enablement

* Wed Nov 08 2017 Paul Gier <pgier@redhat.com> - 2.0.0-1
- Upgrade to 2.0.0 ga

* Fri Oct 27 2017 Paul Gier <pgier@redhat.com> - 2.0.0_rc.2-1
- Upgrade to 2.0.0_rc.2

* Tue Oct 03 2017 Paul Gier <pgier@redhat.com> - 2.0.0_beta.5-1
- Upgrade to 2.0.0_beta.5 with openshift patches

* Fri Sep 01 2017 Paul Gier <pgier@redhat.com> - 2.0.0_beta.2-2.gitcb0f605
- Use sources from forked openshift project
- Don't build the duplicate binary package
- Strip debug info

* Wed Aug 23 2017 Paul Gier <pgier@redhat.com> - 2.0.0_beta.2-1.gita52f082
- First package for Openshift
